controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Ciclista;
use yii\data\SqlDataProvider;
use app\models\Lleva;
use app\models\Etapa;
use app\models\Equipo;
use app\models\Puerto;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }
  /*INICIO DE LAS CONSULTAS*/
    
    //Consulta 1
 
    //Active Record
    public function actionConsulta1a(){
        //Se crea un provedor de datos
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista::find()  -> select('count(*) as Total'),
        ]);
        //se renderiza la vista donde vamos a mostrar los datos
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['Total'],
            "titulo"=>"Consulta 1 con Active Record",
            "enunciado" => "Número de ciclistas que hay",
            "sql"=> "SELECT count(*) from ciclista",
        ]);
    }
    //DAO 
   public function actionConsulta1(){
        $dataProvider=new SqlDataProvider([
            'sql' => 'SELECT count(*) as Total from ciclista',  
         ]);
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['Total'],
            "titulo"=>"Consulta 1 con DAO",
            "enunciado"=>"Número de ciclistas que hay",
            "sql"=>"SELECT count(*) from ciclista",
            
        ]);   
   }
     
    //CONSULTA 2
   
   //CON ACTIVE RECORD
   public function actionConsulta2a(){
       $dataProvider= new ActiveDataProvider([
           'query' => Ciclista::find() ->select('count(*) as Total') ->where("nomequipo='Banesto'"),
       ]);
       
       return $this -> render('resultado',[
           "resultados"=>$dataProvider,
           "campos"=> ['Total' ],
           "titulo" => "Consuta 2 con Active Record",
           "enunciado"=>"Número de ciclistas que hay del equipo Banesto",
           "sql"=>"Select count(*) FROM ciclista WHERE nomequipo='Banesto' ",
       ]);
   }
   //CON DAO
    public function actionConsulta2(){
        $dataProvider = new SqlDataProvider([
            'sql'=>'Select count(*) as Total FROM ciclista WHERE nomequipo="Banesto"',
        ]);
        
        return $this -> render('resultado',[
           "resultados"=>$dataProvider,
           "campos"=> ['Total' ],
           "titulo" => "Consuta 2 con DAO",
           "enunciado"=>"Número de ciclistas que hay del equipo Banesto",
           "sql"=>"Select count(*) FROM ciclista WHERE nomequipo='Banesto' ",
       ]);
    }
    
    //CONSULTA 3
    
    //Consulta con Active Record
    public function actionConsulta3a(){
        $dataProvider= new ActiveDataProvider([
            'query'=> Ciclista::find()->select('AVG(edad) as Media'),
        ]);
        
         return $this -> render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['Media'],
            "titulo"=>"Consulta 3 con Active Record",
            "enunciado"=> "Edad media de los ciclistas",
            "sql"=>"Select AVG(edad) as Media from ciclista",
        ]);
    }
    
    //Consulta con DAO
    public function actionConsulta3(){
        $dataProvider = new SqlDataProvider([
            'sql' => 'Select AVG(edad) as Media from ciclista',
        ]);
        
        return $this -> render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['Media'],
            "titulo"=>"Consulta 3 con DAO",
            "enunciado"=> "Edad media de los ciclistas",
            "sql"=>"Select AVG(edad) as Media from ciclista",
        ]);
    }
  //CONSULTA 4
    //Consulta con Active Record
    
    public function actionConsulta4a(){
        $dataProvider = new ActiveDataProvider([
            'query' => Ciclista:: find()-> select('AVG(edad) as Media') -> where('nomequipo="Banesto"'),
        ]);
        return $this -> render('resultado',[
           "resultados"=>$dataProvider,
            "campos"=>['Media'],
            "titulo"=>"Consulta 4 con Active Record",
            "enunciado"=>"La edad media de los del equipo Banesto",
            "sql"=>"SELECT AVG(edad) FROM ciclista WHERE nomequipo='Banesto' ",
        ]);
    }
    //Consulta con DAO
    public function actionConsulta4(){
        $dataProvider = new SqlDataProvider([
           'sql'=> 'Select AVG(edad) as Media from ciclista where nomequipo="Banesto" ', 
        ]);
        return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['Media'],
            "titulo"=>"Consulta 4 con DAO",
            "enunciado"=>"La edad media de los del equipo Banesto",
            "sql"=>"SELECT AVG(edad) as Media FROM ciclista WHERE nomequipo='Banesto' ",
        ]);
    }
    
    
    //CONSULTA 5
    //consulta con Active Record
    public function actionConsulta5a(){
        $dataProvider = new ActiveDataProvider([
            'query'=>Ciclista::find()-> select('AVG(edad) as Media, nomequipo') ->groupBy('nomequipo'),
        ]);
        
         return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['nomequipo', 'Media'],
            "titulo"=>"Consulta 5 con Active Record",
            "enunciado"=>"La edad media de los ciclistas por cada equipo",
            "sql"=>"SELECT AVG(edad) as Media FROM ciclista GROUP BY nomequipo",
        ]);
    }
    
    //consulta con DAO
    public function actionConsulta5(){
        $dataProvider= new SqlDataProvider([
           'sql'=> 'Select nomequipo, AVG(edad) as Media FROM ciclista GROUP BY nomequipo', 
        ]);
        
          return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['nomequipo', 'Media'],
            "titulo"=>"Consulta 5 con DAO",
            "enunciado"=>"La edad media de los ciclistas por cada equipo",
            "sql"=>"SELECT AVG(edad) as Media FROM ciclista GROUP BY nomequipo",
        ]);
    }
    
//CONSULTA 6
    
    //Consulta con Active Record
     public function actionConsulta6a(){
        $dataProvider = new ActiveDataProvider([
            'query'=>Ciclista::find()-> select('count(*) as Total, nomequipo') ->groupBy('nomequipo'),
        ]);
        
         return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['nomequipo', 'Total'],
            "titulo"=>"Consulta  6 con Active Record",
            "enunciado"=>"El número de ciclistas por equipo",
            "sql"=>"SELECT nomequipo, COUNT(*) as Total FROM ciclista GROUP BY nomequipo",
        ]);
    }
    //consulta con DAO
    public function actionConsulta6(){
        $dataProvider= new SqlDataProvider([
           'sql'=> 'SELECT nomequipo, COUNT(*) as Total FROM ciclista GROUP BY nomequipo', 
        ]);
        
             return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['nomequipo', 'Total'],
            "titulo"=>"Consulta  6 con DAO",
            "enunciado"=>"El número de ciclistas por equipo",
            "sql"=>"SELECT nomequipo, COUNT(*) as Total FROM ciclista GROUP BY nomequipo",
        ]);
        
    }
    

 //CONSULTA 7
    
    //Consulta con Active Record
     public function actionConsulta7a(){
        $dataProvider = new ActiveDataProvider([
            'query'=>Puerto::find()-> select('count(*) as Total') ,
        ]);
        
         return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['Total'],
            "titulo"=>"Consulta 7 con Active Record",
            "enunciado"=>"El número total de puertos",
            "sql"=>"SELECT COUNT(*) FROM puerto",
        ]);
    }
    //consulta con DAO
        public function actionConsulta7(){
        $dataProvider= new SqlDataProvider([
           'sql'=> 'SELECT COUNT(*) as Total FROM puerto', 
        ]);
        
         return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['Total'],
            "titulo"=>"Consulta 7 con DAO",
            "enunciado"=>"El número total de puertos",
            "sql"=>"SELECT COUNT(*) FROM puerto",
        ]);
    }
    
    
    
//CONSULTA 8
    
    //Consulta con Active Record
     public function actionConsulta8a(){
        $dataProvider = new ActiveDataProvider([
            'query'=>Puerto::find()-> select('count(*) as Total') ->where('altura >1500'),
        ]);
        
         return $this -> render('resultado',[
           "resultados"=> $dataProvider,
            "campos"=>['Total'],
            "titulo"=>"Consulta 8 con Active Record",
            "enunciado"=>"El número total de puertos mayores de 1500",
            "sql"=>"SELECT COUNT(*) FROM puerto WHERE altura >1500",
        ]);
    }
    //consulta con DAO
    public function actionConsulta8(){

views/site/about.php
<?php

/** @var yii\web\View $this */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\ContactForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Consultas de selección 2</h1>
    </div>
        
        
<div class="body-content">
         <!-- Inicio de la primera fila-->

        <div class="row">
            <!--Primera consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 1</h3>
                        <p>Número de ciclistas que hay.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta1a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta1'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin primera consulta-->
            
            <!--Segunda consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 2</h3>
                        <p>Número de ciclistas que hay del equipo Banesto.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta2a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta2'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin segunda consulta-->
            
            <!--Tercera consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 3</h3>
                        <p>Edad media de los ciclistas.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta3a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta3'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin Tercera consulta-->
        </div>
         
         <!-- Fin de la primera fila-->
         
         
          
         <!-- Inicio de la Segunda fila-->
         <div class="row">
             <!--Cuarta consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 4</h3>
                        <p>La edad media de los del equipo Banesto.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta4a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta4'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin Cuarta consulta-->
            <!--Quinta consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 5</h3>
                        <p>La edad media de los ciclistas por cada equipo.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta5a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta5'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin Quinta consulta-->
            <!--Sexta consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 6</h3>
                        <p>El número de ciclistas por equipo.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta6a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta6'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin sexta consulta--> 
            
        </div>
        <!-- Fin de la segunda fila--> 
         
        <!-- Inicio de la tercera fila-->
         <div class="row">
             <!--septima consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 7</h3>
                        <p>El número total de puertos.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta7a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta7'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin septima consulta-->
            
            <!--octava consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 8</h3>
                        <p>El número total de puertos mayores de 1500.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta8a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta8'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin octava consulta-->
            <!--Novena consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 9</h3>
                        <p>Listar el nombre de los equipos que tengan más de 4 ciclistas.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta9a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta9'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin novena consulta--> 
            
        </div>
         <!-- Fin de la tercera fila--> 
         
          <!-- Inicio de la carta fila-->
         <div class="row">
             <!--decina consulta-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 10</h3>
                        <p>Listar el nombre de los equipos que tengan más de 4 ciclistas cuya edad esté entre 28 y 32.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta10a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta10'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin decima consulta-->
            <!--consulta once-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 11</h3>
                        <p>Indícame el número de etapas que ha ganado cada uno de los ciclistas.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta11a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta11'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin de la consulta once-->
            
            
             <!--consulta doce-->
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    
                    <div class="card-body tarjeta">
                        <h3>Consulta 12</h3>
                        <p>Indícame el dorsal de los ciclistas que hayan ganado más de una etapa.</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta12a'], ['class' => 'btn btn-primary'] ) ?>
                            <?= Html::a('DAO',['site/consulta12'], ['class' => 'btn btn-warning'] ) ?>

                        </p>
                    </div>
                </div>
                
                
            </div>
            <!-- Fin de la consulta doce-->
            
        </div>
         <!-- Fin de la cuarta fila--> 

    </div>
        

    
</div>

views/site/login.php
<?php

/** @var yii\web\View $this */
/** @var yii\bootstrap4\ActiveForm $form */
/** @var app\models\LoginForm $model */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n{input}\n{error}",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
            'inputOptions' => ['class' => 'col-lg-3 form-control'],
            'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

<div class="jumbotron">
    <h2><?=$titulo?></h2>
    <P class="lead"><?= $enunciado ?></P>
    <div class="well">
        <?= $sql?>
    </div>
    </div>
    <?=    GridView::widget([
        'dataProvider'=>$resultados,
        'columns' => $campos
    ]);?>